// Generated by purs version 0.11.6
"use strict";
var Control_Applicative = require("../Control.Applicative");
var Control_Bind = require("../Control.Bind");
var Control_Semigroupoid = require("../Control.Semigroupoid");
var Data_Char_Unicode = require("../Data.Char.Unicode");
var Data_Eq = require("../Data.Eq");
var Data_Foldable = require("../Data.Foldable");
var Data_Function = require("../Data.Function");
var Data_Functor = require("../Data.Functor");
var Data_HeytingAlgebra = require("../Data.HeytingAlgebra");
var Data_List = require("../Data.List");
var Data_List_Types = require("../Data.List.Types");
var Data_Map = require("../Data.Map");
var Data_Maybe = require("../Data.Maybe");
var Data_Monoid = require("../Data.Monoid");
var Data_Ord = require("../Data.Ord");
var Data_Semigroup = require("../Data.Semigroup");
var Data_Set = require("../Data.Set");
var Data_String_Util = require("../Data.String.Util");
var Data_Unit = require("../Data.Unit");
var Doc = require("../Doc");
var IRGraph = require("../IRGraph");
var Prelude = require("../Prelude");
var Utils = require("../Utils");
var tokenCase = function (tokenType) {
    return Doc.line("case JsonToken." + (tokenType + ":"));
};
var stringIfTrue = function (v) {
    return function (v1) {
        if (v) {
            return v1;
        };
        if (!v) {
            return "";
        };
        throw new Error("Failed pattern match at Language.CSharp line 127, column 1 - line 127, column 44: " + [ v.constructor.name, v1.constructor.name ]);
    };
};
var renderNullDeserializer = function (types) {
    return Control_Applicative.when(Doc.applicativeDoc)(Data_Set.member(IRGraph.ordIRType)(IRGraph.IRNull.value)(types))(Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(tokenCase("Null"))(function () {
        return Doc.indent(Doc.line("break;"));
    }));
};
var isValueType = function (v) {
    if (v instanceof IRGraph.IRInteger) {
        return true;
    };
    if (v instanceof IRGraph.IRDouble) {
        return true;
    };
    if (v instanceof IRGraph.IRBool) {
        return true;
    };
    return false;
};
var renderUnionToCSharp = function (ur) {
    var v = IRGraph.nullableFromSet(IRGraph.unionToSet(ur));
    if (v instanceof Data_Maybe.Just) {
        return renderNullableToCSharp(v.value0);
    };
    if (v instanceof Data_Maybe.Nothing) {
        return Doc.lookupUnionName(ur);
    };
    throw new Error("Failed pattern match at Language.CSharp line 73, column 5 - line 75, column 34: " + [ v.constructor.name ]);
};
var renderTypeToCSharp = function (v) {
    if (v instanceof IRGraph.IRNothing) {
        return Control_Applicative.pure(Doc.applicativeDoc)("object");
    };
    if (v instanceof IRGraph.IRNull) {
        return Control_Applicative.pure(Doc.applicativeDoc)("object");
    };
    if (v instanceof IRGraph.IRInteger) {
        return Control_Applicative.pure(Doc.applicativeDoc)("long");
    };
    if (v instanceof IRGraph.IRDouble) {
        return Control_Applicative.pure(Doc.applicativeDoc)("double");
    };
    if (v instanceof IRGraph.IRBool) {
        return Control_Applicative.pure(Doc.applicativeDoc)("bool");
    };
    if (v instanceof IRGraph.IRString) {
        return Control_Applicative.pure(Doc.applicativeDoc)("string");
    };
    if (v instanceof IRGraph.IRArray) {
        return Control_Bind.bind(Doc.bindDoc)(renderTypeToCSharp(v.value0))(function (v1) {
            return Control_Applicative.pure(Doc.applicativeDoc)(v1 + "[]");
        });
    };
    if (v instanceof IRGraph.IRClass) {
        return Doc.lookupClassName(v.value0);
    };
    if (v instanceof IRGraph.IRMap) {
        return Control_Bind.bind(Doc.bindDoc)(renderTypeToCSharp(v.value0))(function (v1) {
            return Control_Applicative.pure(Doc.applicativeDoc)("Dictionary<string, " + (v1 + ">"));
        });
    };
    if (v instanceof IRGraph.IRUnion) {
        return renderUnionToCSharp(v.value0);
    };
    throw new Error("Failed pattern match at Language.CSharp line 78, column 22 - line 92, column 41: " + [ v.constructor.name ]);
};
var renderNullableToCSharp = function (x) {
    return Control_Bind.bind(Doc.bindDoc)(renderTypeToCSharp(x))(function (v) {
        return Control_Applicative.pure(Doc.applicativeDoc)((function () {
            var $40 = isValueType(x);
            if ($40) {
                return v + "?";
            };
            return v;
        })());
    });
};
var isStartCharacter = function (c) {
    return Data_String_Util.isLetterOrLetterNumber(c) || c === "_";
};
var isPartCharacter = function (c) {
    var v = Data_Char_Unicode.generalCategory(c);
    if (v instanceof Data_Maybe.Just && v.value0 instanceof Data_Char_Unicode.DecimalNumber) {
        return true;
    };
    if (v instanceof Data_Maybe.Just && v.value0 instanceof Data_Char_Unicode.ConnectorPunctuation) {
        return true;
    };
    if (v instanceof Data_Maybe.Just && v.value0 instanceof Data_Char_Unicode.NonSpacingMark) {
        return true;
    };
    if (v instanceof Data_Maybe.Just && v.value0 instanceof Data_Char_Unicode.SpacingCombiningMark) {
        return true;
    };
    if (v instanceof Data_Maybe.Just && v.value0 instanceof Data_Char_Unicode.Format) {
        return true;
    };
    return isStartCharacter(c);
};
var legalize = Data_String_Util.legalizeCharacters(isPartCharacter);
var getDecoderHelperPrefix = function (topLevelName) {
    return Doc.getForSingleOrMultipleTopLevels("")(topLevelName);
};
var renderJsonConverter = Control_Bind.bind(Doc.bindDoc)(Doc.getUnionNames)(function (v) {
    var haveUnions = !Data_Map.isEmpty(v);
    var names = Data_Map.values(v);
    return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("public class Convert" + stringIfTrue(haveUnions)(" : JsonConverter")))(function () {
        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("{"))(function () {
            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.indent(Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("// Serialize/deserialize helpers"))(function () {
                return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.forEachTopLevel_(function (topLevelName) {
                    return function (topLevelType) {
                        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.blank)(function () {
                            return Control_Bind.bind(Doc.bindDoc)(renderTypeToCSharp(topLevelType))(function (v1) {
                                return Control_Bind.bind(Doc.bindDoc)(getDecoderHelperPrefix(topLevelName))(function (v2) {
                                    return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("public static " + (v1 + (" " + (v2 + ("FromJson(string json) => JsonConvert.DeserializeObject<" + (v1 + ">(json, Settings);")))))))(function () {
                                        return Doc.line("public static string ToJson(" + (v1 + " o) => JsonConvert.SerializeObject(o, Settings);"));
                                    });
                                });
                            });
                        });
                    };
                }))(function () {
                    return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.blank)(function () {
                        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("// JsonConverter stuff"))(function () {
                            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Control_Applicative.when(Doc.applicativeDoc)(haveUnions)(Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.blank)(function () {
                                return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("public override bool CanConvert(Type t)"))(function () {
                                    return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("{"))(function () {
                                        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.indent(Doc.line("return " + (Data_Foldable.intercalate(Data_List_Types.foldableList)(Data_Monoid.monoidString)(" || ")(Data_Functor.map(Data_List_Types.functorList)(function (n) {
                                            return "t == typeof(" + (n + ")");
                                        })(names)) + ";"))))(function () {
                                            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("}"))(function () {
                                                return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.blank)(function () {
                                                    return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("public override object ReadJson(JsonReader reader, Type t, object existingValue, JsonSerializer serializer)"))(function () {
                                                        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("{"))(function () {
                                                            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.indent(Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Data_Foldable.for_(Doc.applicativeDoc)(Data_List_Types.foldableList)(names)(function (name) {
                                                                return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("if (t == typeof(" + (name + "))")))(function () {
                                                                    return Doc.indent(Doc.line("return new " + (name + "(reader, serializer);")));
                                                                });
                                                            }))(function () {
                                                                return Doc.line("throw new Exception(\"Unknown type\");");
                                                            })))(function () {
                                                                return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("}"))(function () {
                                                                    return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.blank)(function () {
                                                                        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("public override void WriteJson(JsonWriter writer, object value, JsonSerializer serializer)"))(function () {
                                                                            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("{"))(function () {
                                                                                return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.indent(Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("var t = value.GetType();"))(function () {
                                                                                    return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Data_Foldable.for_(Doc.applicativeDoc)(Data_List_Types.foldableList)(names)(function (name) {
                                                                                        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("if (t == typeof(" + (name + ")) {")))(function () {
                                                                                            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.indent(Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("((" + (name + ")value).WriteJson(writer, serializer);")))(function () {
                                                                                                return Doc.line("return;");
                                                                                            })))(function () {
                                                                                                return Doc.line("}");
                                                                                            });
                                                                                        });
                                                                                    }))(function () {
                                                                                        return Doc.line("throw new Exception(\"Unknown type\");");
                                                                                    });
                                                                                })))(function () {
                                                                                    return Doc.line("}");
                                                                                });
                                                                            });
                                                                        });
                                                                    });
                                                                });
                                                            });
                                                        });
                                                    });
                                                });
                                            });
                                        });
                                    });
                                });
                            })))(function () {
                                return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.blank)(function () {
                                    return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("static JsonSerializerSettings Settings = new JsonSerializerSettings"))(function () {
                                        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("{"))(function () {
                                            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.indent(Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("MetadataPropertyHandling = MetadataPropertyHandling.Ignore,"))(function () {
                                                return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("DateParseHandling = DateParseHandling.None,"))(function () {
                                                    return Control_Applicative.when(Doc.applicativeDoc)(haveUnions)(Doc.line("Converters = { new Convert() },"));
                                                });
                                            })))(function () {
                                                return Doc.line("};");
                                            });
                                        });
                                    });
                                });
                            });
                        });
                    });
                });
            })))(function () {
                return Doc.line("}");
            });
        });
    });
});
var forbiddenNames = [ "Convert", "JsonConverter", "Type" ];
var deserialize = function (fieldName) {
    return function (typeName) {
        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line(fieldName + (" = serializer.Deserialize<" + (typeName + ">(reader);"))))(function () {
            return Doc.line("break;");
        });
    };
};
var csNameStyle = function ($67) {
    return Data_String_Util.startWithLetter(isStartCharacter)(true)(Data_String_Util.camelCase(legalize($67)));
};
var nameForClass = function (v) {
    return csNameStyle(Doc.combineNames(v.names));
};
var renderCSharpClass = function (className) {
    return function (properties) {
        var propertyNames = Doc.transformPropertyNames(Doc.simpleNamer(Data_Ord.ordString)(csNameStyle))(function (v) {
            return "Other" + v;
        })([ className ])(properties);
        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("public class " + className))(function () {
            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("{"))(function () {
                return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.indent(Doc.forEachProperty_(properties)(propertyNames)(function (pname) {
                    return function (ptype) {
                        return function (csPropName) {
                            return function (isLast) {
                                return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("[JsonProperty(\"" + (Data_String_Util.stringEscape(pname) + "\")]")))(function () {
                                    return Control_Bind.bind(Doc.bindDoc)(renderTypeToCSharp(ptype))(function (v) {
                                        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("public " + (v + (" " + (csPropName + " { get; set; }")))))(function () {
                                            return Control_Applicative.unless(Doc.applicativeDoc)(isLast)(Doc.blank);
                                        });
                                    });
                                });
                            };
                        };
                    };
                })))(function () {
                    return Doc.line("}");
                });
            });
        });
    };
};
var unionFieldName = function (t) {
    return Data_Functor.map(Doc.functorDoc)(csNameStyle)(Doc.getTypeNameForUnion(t));
};
var deserializeType = function (t) {
    return Control_Bind.bind(Doc.bindDoc)(unionFieldName(t))(function (v) {
        return Control_Bind.bind(Doc.bindDoc)(renderTypeToCSharp(t))(function (v1) {
            return deserialize(v)(v1);
        });
    });
};
var renderDoubleDeserializer = function (types) {
    return Control_Applicative.when(Doc.applicativeDoc)(Data_Set.member(IRGraph.ordIRType)(IRGraph.IRDouble.value)(types))(Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Control_Applicative.unless(Doc.applicativeDoc)(Data_Set.member(IRGraph.ordIRType)(IRGraph.IRInteger.value)(types))(tokenCase("Integer")))(function () {
        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(tokenCase("Float"))(function () {
            return Doc.indent(deserializeType(IRGraph.IRDouble.value));
        });
    }));
};
var renderGenericDeserializer = function (predicate) {
    return function (tokenType) {
        return function (types) {
            var v = Data_Foldable.find(Data_Set.foldableSet)(predicate)(types);
            if (v instanceof Data_Maybe.Nothing) {
                return Control_Applicative.pure(Doc.applicativeDoc)(Data_Unit.unit);
            };
            if (v instanceof Data_Maybe.Just) {
                return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(tokenCase(tokenType))(function () {
                    return Doc.indent(deserializeType(v.value0));
                });
            };
            throw new Error("Failed pattern match at Language.CSharp line 245, column 5 - line 250, column 30: " + [ v.constructor.name ]);
        };
    };
};
var renderPrimitiveDeserializer = function (tokenTypes) {
    return function (t) {
        return function (types) {
            return Control_Applicative.when(Doc.applicativeDoc)(Data_Set.member(IRGraph.ordIRType)(t)(types))(Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Data_Foldable.for_(Doc.applicativeDoc)(Data_List_Types.foldableList)(tokenTypes)(function (tokenType) {
                return tokenCase(tokenType);
            }))(function () {
                return Doc.indent(deserializeType(t));
            }));
        };
    };
};
var renderCSharpUnion = function (name) {
    return function (allTypes) {
        var v = Utils.removeElement(IRGraph.ordIRType)(function (v1) {
            return Data_Eq.eq(IRGraph.eqIRType)(v1)(IRGraph.IRNull.value);
        })(allTypes);
        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("public struct " + name))(function () {
            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("{"))(function () {
                return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.indent(Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Data_Foldable.for_(Doc.applicativeDoc)(Data_Set.foldableSet)(v.rest)(function (t) {
                    return Control_Bind.bind(Doc.bindDoc)(renderNullableToCSharp(t))(function (v1) {
                        return Control_Bind.bind(Doc.bindDoc)(unionFieldName(t))(function (v2) {
                            return Doc.line("public " + (v1 + (" " + (v2 + ";"))));
                        });
                    });
                }))(function () {
                    return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.blank)(function () {
                        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("public " + (name + "(JsonReader reader, JsonSerializer serializer)")))(function () {
                            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("{"))(function () {
                                return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.indent(Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Data_Foldable.for_(Doc.applicativeDoc)(Data_List_Types.foldableList)(Data_List.fromFoldable(Data_Set.foldableSet)(v.rest))(function (field) {
                                    return Control_Bind.bind(Doc.bindDoc)(unionFieldName(field))(function (v1) {
                                        return Doc.line(v1 + " = null;");
                                    });
                                }))(function () {
                                    return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.blank)(function () {
                                        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("switch (reader.TokenType)"))(function () {
                                            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("{"))(function () {
                                                return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.indent(Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(renderNullDeserializer(allTypes))(function () {
                                                    return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(renderPrimitiveDeserializer(Data_List.singleton("Integer"))(IRGraph.IRInteger.value)(allTypes))(function () {
                                                        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(renderDoubleDeserializer(allTypes))(function () {
                                                            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(renderPrimitiveDeserializer(Data_List.singleton("Boolean"))(IRGraph.IRBool.value)(allTypes))(function () {
                                                                return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(renderPrimitiveDeserializer(new Data_List_Types.Cons("String", new Data_List_Types.Cons("Date", Data_List_Types.Nil.value)))(IRGraph.IRString.value)(allTypes))(function () {
                                                                    return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(renderGenericDeserializer(IRGraph.isArray)("StartArray")(allTypes))(function () {
                                                                        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(renderGenericDeserializer(IRGraph.isClass)("StartObject")(allTypes))(function () {
                                                                            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(renderGenericDeserializer(IRGraph.isMap)("StartObject")(allTypes))(function () {
                                                                                return Doc.line("default: throw new Exception(\"Cannot convert " + (name + "\");"));
                                                                            });
                                                                        });
                                                                    });
                                                                });
                                                            });
                                                        });
                                                    });
                                                })))(function () {
                                                    return Doc.line("}");
                                                });
                                            });
                                        });
                                    });
                                })))(function () {
                                    return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("}"))(function () {
                                        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.blank)(function () {
                                            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("public void WriteJson(JsonWriter writer, JsonSerializer serializer)"))(function () {
                                                return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("{"))(function () {
                                                    return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.indent(Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Data_Foldable.for_(Doc.applicativeDoc)(Data_List_Types.foldableList)(Data_List.fromFoldable(Data_Set.foldableSet)(v.rest))(function (field) {
                                                        return Control_Bind.bind(Doc.bindDoc)(unionFieldName(field))(function (v1) {
                                                            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("if (" + (v1 + " != null) {")))(function () {
                                                                return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.indent(Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("serializer.Serialize(writer, " + (v1 + ");")))(function () {
                                                                    return Doc.line("return;");
                                                                })))(function () {
                                                                    return Doc.line("}");
                                                                });
                                                            });
                                                        });
                                                    }))(function () {
                                                        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Control_Applicative.when(Doc.applicativeDoc)(Data_Maybe.isJust(v.element))(Doc.line("writer.WriteNull();")))(function () {
                                                            return Control_Applicative.when(Doc.applicativeDoc)(Data_Maybe.isNothing(v.element))(Doc.line("throw new Exception(\"Union must not be null\");"));
                                                        });
                                                    })))(function () {
                                                        return Doc.line("}");
                                                    });
                                                });
                                            });
                                        });
                                    });
                                });
                            });
                        });
                    });
                })))(function () {
                    return Doc.line("}");
                });
            });
        });
    };
};
var csharpDoc = Control_Bind.bind(Doc.bindDoc)(Doc.getModuleName(csNameStyle))(function (v) {
    return Control_Bind.bind(Doc.bindDoc)(Doc.getForSingleOrMultipleTopLevels("")(" one of these"))(function (v1) {
        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("// To parse this JSON data, add NuGet 'Newtonsoft.Json' then do" + (v1 + ":")))(function () {
            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.forEachTopLevel_(function (topLevelName) {
                return function (topLevelType) {
                    return Control_Bind.bind(Doc.bindDoc)(getDecoderHelperPrefix(topLevelName))(function (v2) {
                        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("//"))(function () {
                            return Doc.line("//    var data = " + (v + (".Convert." + (v2 + "FromJson(jsonString);"))));
                        });
                    });
                };
            }))(function () {
                return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("//"))(function () {
                    return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("namespace " + v))(function () {
                        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("{"))(function () {
                            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.indent(Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("using System;\x0ausing System.Net;\x0ausing System.Collections.Generic;\x0a\x0ausing Newtonsoft.Json;\x0a"))(function () {
                                return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.renderRenderItems(Doc.blank)(Data_Maybe.Nothing.value)(renderCSharpClass)(new Data_Maybe.Just(renderCSharpUnion)))(function () {
                                    return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.blank)(function () {
                                        return renderJsonConverter;
                                    });
                                });
                            })))(function () {
                                return Doc.line("}");
                            });
                        });
                    });
                });
            });
        });
    });
});
var renderer = {
    name: "C#", 
    aceMode: "csharp", 
    extension: "cs", 
    doc: csharpDoc, 
    transforms: {
        nameForClass: Doc.simpleNamer(IRGraph.ordIRClassData)(nameForClass), 
        nextName: function (s) {
            return "Other" + s;
        }, 
        forbiddenNames: forbiddenNames, 
        topLevelName: Doc.noForbidNamer(Data_Ord.ordString)(csNameStyle), 
        unions: new Data_Maybe.Just({
            predicate: Doc.unionIsNotSimpleNullable, 
            properName: Doc.simpleNamer(IRGraph.ordNamed(Data_Set.ordSet(Data_Ord.ordString)))(function ($68) {
                return csNameStyle(Doc.combineNames($68));
            }), 
            nameFromTypes: Doc.simpleNamer(Data_Ord.ordArray(Data_Ord.ordString))(Doc.unionNameIntercalated(csNameStyle)("Or"))
        })
    }
};
module.exports = {
    renderer: renderer
};
//# sourceMappingURL=index.js.map
