// Generated by purs version 0.11.6
"use strict";
var Control_Applicative = require("../Control.Applicative");
var Control_Bind = require("../Control.Bind");
var Control_Semigroupoid = require("../Control.Semigroupoid");
var Data_Array = require("../Data.Array");
var Data_Char_Unicode = require("../Data.Char.Unicode");
var Data_Eq = require("../Data.Eq");
var Data_Foldable = require("../Data.Foldable");
var Data_Function = require("../Data.Function");
var Data_Functor = require("../Data.Functor");
var Data_HeytingAlgebra = require("../Data.HeytingAlgebra");
var Data_List_Types = require("../Data.List.Types");
var Data_Map = require("../Data.Map");
var Data_Maybe = require("../Data.Maybe");
var Data_Ord = require("../Data.Ord");
var Data_Semigroup = require("../Data.Semigroup");
var Data_Set = require("../Data.Set");
var Data_String = require("../Data.String");
var Data_String_Util = require("../Data.String.Util");
var Data_Tuple = require("../Data.Tuple");
var Data_Unit = require("../Data.Unit");
var Doc = require("../Doc");
var IRGraph = require("../IRGraph");
var Prelude = require("../Prelude");
var Utils = require("../Utils");
var supportFunctions = Doc.line("// Helpers\x0a\x0afileprivate func convertArray<T>(_ converter: (Any) -> T?, _ json: Any) -> [T]? {\x0a    guard let jsonArr = json as? [Any] else { return nil }\x0a    var arr = [T]()\x0a    for v in jsonArr {\x0a        if let converted = converter(v) {\x0a            arr.append(converted)\x0a        } else {\x0a            return nil\x0a        }\x0a    }\x0a    return arr\x0a}\x0a\x0afileprivate func convertOptional<T>(_ converter: (Any) -> T?, _ json: Any?) -> T?? {\x0a    guard let v = json else { return .some(nil) }\x0a    return converter(v)\x0a}\x0a\x0afileprivate func convertDict<T>(_ converter: (Any) -> T?, _ json: Any?) -> [String: T]? {\x0a    guard let jsonDict = json as? [String: Any] else { return nil }\x0a    var dict = [String: T]()\x0a    for (k, v) in jsonDict {\x0a        if let converted = converter(v) {\x0a            dict[k] = converted\x0a        } else {\x0a            return nil\x0a        }\x0a    }\x0a    return dict\x0a}\x0a\x0afileprivate func convertToAny<T>(_ dictionary: [String: T], _ converter: (T) -> Any) -> Any {\x0a    var result = [String: Any]()\x0a    for (k, v) in dictionary {\x0a        result[k] = converter(v)\x0a    }\x0a    return result\x0a}\x0a\x0afileprivate func convertDouble(_ v: Any) -> Double? {\x0a    if let w = v as? Double { return w }\x0a    if let w = v as? Int { return Double(w) }\x0a    return nil\x0a}\x0a\x0afileprivate let falseType = NSNumber(value: false).objCType\x0afileprivate let trueNumber = NSNumber(value: true)\x0afileprivate let trueType = trueNumber.objCType\x0a\x0afileprivate func convertBool(_ v: Any?) -> Bool? {\x0a    guard let number = v as? NSNumber\x0a    else {\x0a        if let b = v as? Bool {\x0a            return b\x0a        }\x0a        return nil\x0a    }\x0a    \x0a    if number.objCType != falseType && number.objCType != trueType {\x0a        return nil\x0a    }\x0a    return number.isEqual(trueNumber)\x0a}\x0a\x0afileprivate func removeNSNull(_ v: Any?) -> Any? {\x0a    if let w = v {\x0a        if w is NSNull {\x0a            return nil\x0a        }\x0a        return w\x0a    }\x0a    return nil\x0a}\x0a\x0afileprivate func checkNull(_ v: Any?) -> Any?? {\x0a    if v != nil { return .none }\x0a    return .some(nil)\x0a}");
var stringEscape = (function () {
    var unicodeEscape = function (i) {
        return "\\u{" + (Data_String.fromCharArray(Data_String_Util.intToHex(0)(i)) + "}");
    };
    return Data_String_Util.genericStringEscape(unicodeEscape);
})();
var renderUnion = function (ur) {
    var v = IRGraph.nullableFromSet(IRGraph.unionToSet(ur));
    if (v instanceof Data_Maybe.Just) {
        return Control_Bind.bind(Doc.bindDoc)(renderType(v.value0))(function (v1) {
            return Control_Applicative.pure(Doc.applicativeDoc)(v1 + "?");
        });
    };
    if (v instanceof Data_Maybe.Nothing) {
        return Doc.lookupUnionName(ur);
    };
    throw new Error("Failed pattern match at Language.Swift line 189, column 5 - line 193, column 34: " + [ v.constructor.name ]);
};
var renderType = function (v) {
    if (v instanceof IRGraph.IRNothing) {
        return Control_Applicative.pure(Doc.applicativeDoc)("Any?");
    };
    if (v instanceof IRGraph.IRNull) {
        return Control_Applicative.pure(Doc.applicativeDoc)("Any?");
    };
    if (v instanceof IRGraph.IRInteger) {
        return Control_Applicative.pure(Doc.applicativeDoc)("Int");
    };
    if (v instanceof IRGraph.IRDouble) {
        return Control_Applicative.pure(Doc.applicativeDoc)("Double");
    };
    if (v instanceof IRGraph.IRBool) {
        return Control_Applicative.pure(Doc.applicativeDoc)("Bool");
    };
    if (v instanceof IRGraph.IRString) {
        return Control_Applicative.pure(Doc.applicativeDoc)("String");
    };
    if (v instanceof IRGraph.IRArray) {
        return Control_Bind.bind(Doc.bindDoc)(renderType(v.value0))(function (v1) {
            return Control_Applicative.pure(Doc.applicativeDoc)("[" + (v1 + "]"));
        });
    };
    if (v instanceof IRGraph.IRClass) {
        return Doc.lookupClassName(v.value0);
    };
    if (v instanceof IRGraph.IRMap) {
        return Control_Bind.bind(Doc.bindDoc)(renderType(v.value0))(function (v1) {
            return Control_Applicative.pure(Doc.applicativeDoc)("[String: " + (v1 + "]"));
        });
    };
    if (v instanceof IRGraph.IRUnion) {
        return renderUnion(v.value0);
    };
    throw new Error("Failed pattern match at Language.Swift line 196, column 14 - line 210, column 33: " + [ v.constructor.name ]);
};
var renderTopLevelAlias = function (topLevelName) {
    return function (topLevelType) {
        return Control_Bind.bind(Doc.bindDoc)(renderType(topLevelType))(function (v) {
            return Doc.line("typealias " + (topLevelName + (" = " + v)));
        });
    };
};
var legalize = (function () {
    var isPartCharacter = function (c) {
        return c === "_" || Data_Char_Unicode.isAlphaNum(c);
    };
    return Data_String_Util.legalizeCharacters(isPartCharacter);
})();
var swiftNameStyle = function (isUpper) {
    var isStartCharacter = function (c) {
        return c === "_" || Data_Char_Unicode.isAlphaNum(c) && !Data_Char_Unicode.isDigit(c);
    };
    return function ($135) {
        return Data_String_Util.startWithLetter(isStartCharacter)(isUpper)(Data_String_Util.camelCase(legalize($135)));
    };
};
var makePropertyNames = function (properties) {
    return function (suffix) {
        return function (forbidden) {
            var otherField = function (name) {
                return "other" + Data_String_Util.capitalize(name);
            };
            var fieldNamer = function (suffix1) {
                return Doc.simpleNamer(Data_Ord.ordString)(function (name) {
                    return swiftNameStyle(false)(name) + suffix1;
                });
            };
            return Doc.transformPropertyNames(fieldNamer(suffix))(otherField)(forbidden)(properties);
        };
    };
};
var nameForClass = function (v) {
    return swiftNameStyle(true)(Doc.combineNames(v.names));
};
var keywords = [ "associatedtype", "class", "deinit", "enum", "extension", "fileprivate", "func", "import", "init", "inout", "internal", "let", "open", "operator", "private", "protocol", "public", "static", "struct", "subscript", "typealias", "var", "break", "case", "continue", "default", "defer", "do", "else", "fallthrough", "for", "guard", "if", "in", "repeat", "return", "switch", "where", "while", "as", "Any", "catch", "false", "is", "nil", "rethrows", "super", "self", "Self", "throw", "throws", "true", "try", "_", "associativity", "convenience", "dynamic", "didSet", "final", "get", "infix", "indirect", "lazy", "left", "mutating", "nonmutating", "optional", "override", "postfix", "precedence", "prefix", "Protocol", "required", "right", "set", "Type", "unowned", "weak", "willSet", "String", "Int", "Double", "Bool", "Data", "CommandLine", "FileHandle", "JSONSerialization", "checkNull", "removeNSNull", "nilToNSNull", "convertArray", "convertOptional", "convertDict", "convertDouble" ];
var renderClassDefinition = function (className) {
    return function (properties) {
        var forbidden = Data_Semigroup.append(Data_Semigroup.semigroupArray)(keywords)([ "json", "any" ]);
        var propertyNames = makePropertyNames(properties)("")(forbidden);
        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("struct " + (className + " {")))(function () {
            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.indent(Doc.forEachProperty_(properties)(propertyNames)(function (v) {
                return function (ptype) {
                    return function (fieldName) {
                        return function (v1) {
                            return Control_Bind.bind(Doc.bindDoc)(renderType(ptype))(function (v2) {
                                return Doc.line("let " + (fieldName + (": " + v2)));
                            });
                        };
                    };
                };
            })))(function () {
                return Doc.line("}");
            });
        });
    };
};
var convertToAny = function (v) {
    return function ($$var) {
        if (v instanceof IRGraph.IRArray) {
            return Control_Bind.bind(Doc.bindDoc)(convertToAny(v.value0)("$0"))(function (v1) {
                return Control_Applicative.pure(Doc.applicativeDoc)($$var + (".map({ " + (v1 + " }) as Any")));
            });
        };
        if (v instanceof IRGraph.IRMap) {
            return Control_Bind.bind(Doc.bindDoc)(convertToAny(v.value0)("$0"))(function (v1) {
                return Control_Applicative.pure(Doc.applicativeDoc)("convertToAny(" + ($$var + (", { " + (v1 + " })"))));
            });
        };
        if (v instanceof IRGraph.IRClass) {
            return Control_Applicative.pure(Doc.applicativeDoc)($$var + ".any");
        };
        if (v instanceof IRGraph.IRUnion) {
            var v1 = IRGraph.nullableFromSet(IRGraph.unionToSet(v.value0));
            if (v1 instanceof Data_Maybe.Just) {
                return Control_Bind.bind(Doc.bindDoc)(convertToAny(v1.value0)("$0"))(function (v2) {
                    return Control_Applicative.pure(Doc.applicativeDoc)($$var + (".map({ " + (v2 + " }) ?? NSNull()")));
                });
            };
            if (v1 instanceof Data_Maybe.Nothing) {
                return Control_Applicative.pure(Doc.applicativeDoc)($$var + ".any");
            };
            throw new Error("Failed pattern match at Language.Swift line 268, column 5 - line 274, column 1: " + [ v1.constructor.name ]);
        };
        if (v instanceof IRGraph.IRNothing) {
            return Control_Applicative.pure(Doc.applicativeDoc)($$var + " ?? NSNull()");
        };
        if (v instanceof IRGraph.IRNull) {
            return Control_Applicative.pure(Doc.applicativeDoc)("NSNull() as Any");
        };
        return Control_Applicative.pure(Doc.applicativeDoc)($$var + " as Any");
    };
};
var convertAnyFunc = function (v) {
    if (v instanceof IRGraph.IRClass) {
        return Control_Bind.bind(Doc.bindDoc)(Doc.lookupClassName(v.value0))(function (v1) {
            return Control_Applicative.pure(Doc.applicativeDoc)(v1 + ".init(fromAny:)");
        });
    };
    if (v instanceof IRGraph.IRUnion) {
        var v1 = IRGraph.nullableFromSet(IRGraph.unionToSet(v.value0));
        if (v1 instanceof Data_Maybe.Just) {
            return Control_Bind.bind(Doc.bindDoc)(convertAnyFunc(v1.value0))(function (v2) {
                return Control_Applicative.pure(Doc.applicativeDoc)("{ (json: Any) in convertOptional(" + (v2 + ", json) }"));
            });
        };
        if (v1 instanceof Data_Maybe.Nothing) {
            return Control_Bind.bind(Doc.bindDoc)(Doc.lookupUnionName(v.value0))(function (v2) {
                return Control_Applicative.pure(Doc.applicativeDoc)(v2 + ".fromJson");
            });
        };
        throw new Error("Failed pattern match at Language.Swift line 245, column 9 - line 252, column 5: " + [ v1.constructor.name ]);
    };
    if (v instanceof IRGraph.IRDouble) {
        return Control_Applicative.pure(Doc.applicativeDoc)("convertDouble");
    };
    if (v instanceof IRGraph.IRNull) {
        return Control_Applicative.pure(Doc.applicativeDoc)("checkNull");
    };
    return Control_Bind.bind(Doc.bindDoc)(convertAny(v)("$0"))(function (v1) {
        return Control_Applicative.pure(Doc.applicativeDoc)("{ " + (v1 + " }"));
    });
};
var convertAny = function (v) {
    return function ($$var) {
        if (v instanceof IRGraph.IRArray) {
            return Control_Bind.bind(Doc.bindDoc)(convertAnyFunc(v.value0))(function (v1) {
                return Control_Applicative.pure(Doc.applicativeDoc)("convertArray(" + (v1 + (", " + ($$var + ")"))));
            });
        };
        if (v instanceof IRGraph.IRMap) {
            return Control_Bind.bind(Doc.bindDoc)(convertAnyFunc(v.value0))(function (v1) {
                return Control_Applicative.pure(Doc.applicativeDoc)("convertDict(" + (v1 + (", " + ($$var + ")"))));
            });
        };
        if (v instanceof IRGraph.IRUnion) {
            var v1 = IRGraph.nullableFromSet(IRGraph.unionToSet(v.value0));
            if (v1 instanceof Data_Maybe.Just) {
                return Control_Bind.bind(Doc.bindDoc)(convertAnyFunc(v1.value0))(function (v2) {
                    return Control_Applicative.pure(Doc.applicativeDoc)("convertOptional(" + (v2 + (", " + ($$var + ")"))));
                });
            };
            if (v1 instanceof Data_Maybe.Nothing) {
                return Control_Bind.bind(Doc.bindDoc)(Doc.lookupUnionName(v.value0))(function (v2) {
                    return Control_Applicative.pure(Doc.applicativeDoc)(v2 + (".fromJson(" + ($$var + ")")));
                });
            };
            throw new Error("Failed pattern match at Language.Swift line 220, column 5 - line 227, column 1: " + [ v1.constructor.name ]);
        };
        if (v instanceof IRGraph.IRNothing) {
            return Control_Applicative.pure(Doc.applicativeDoc)($$var);
        };
        if (v instanceof IRGraph.IRBool) {
            return Control_Applicative.pure(Doc.applicativeDoc)("convertBool(" + ($$var + ")"));
        };
        if (v instanceof IRGraph.IRInteger) {
            return Control_Applicative.pure(Doc.applicativeDoc)($$var + " as? Int");
        };
        if (v instanceof IRGraph.IRString) {
            return Control_Applicative.pure(Doc.applicativeDoc)($$var + " as? String");
        };
        return Control_Bind.bind(Doc.bindDoc)(convertAnyFunc(v))(function (v1) {
            return Control_Applicative.pure(Doc.applicativeDoc)(v1 + ("(" + ($$var + ")")));
        });
    };
};
var renderClassExtension = function (className) {
    return function (properties) {
        var forbidden = Data_Semigroup.append(Data_Semigroup.semigroupArray)(keywords)([ "jsonUntyped", "json" ]);
        var propertyNames = makePropertyNames(properties)("")(forbidden);
        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("extension " + (className + " {")))(function () {
            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.indent(Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("fileprivate init?(fromAny any: Any) {"))(function () {
                return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Control_Applicative.unless(Doc.applicativeDoc)(Data_Map.isEmpty(properties))(Doc.indent(Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("guard let json = any as? [String: Any] else { return nil }"))(function () {
                    var forbiddenForUntyped = Data_Semigroup.append(Data_Semigroup.semigroupArray)(forbidden)(Data_Array.fromFoldable(Data_List_Types.foldableList)(Data_Map.keys(propertyNames)));
                    var untypedNames = makePropertyNames(properties)("Any")(forbiddenForUntyped);
                    var forbiddenForConverted = Data_Semigroup.append(Data_Semigroup.semigroupArray)(forbiddenForUntyped)(Data_Array.fromFoldable(Data_List_Types.foldableList)(Data_Map.keys(untypedNames)));
                    return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.forEachProperty_(properties)(untypedNames)(function (pname) {
                        return function (ptype) {
                            return function (untypedName) {
                                return function (v) {
                                    return Control_Applicative.when(Doc.applicativeDoc)(IRGraph.canBeNull(ptype))(Doc.line("let " + (untypedName + (" = removeNSNull(json[\"" + (stringEscape(pname) + "\"])")))));
                                };
                            };
                        };
                    }))(function () {
                        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("guard"))(function () {
                            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.indent(Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.forEachProperty_(properties)(untypedNames)(function (pname) {
                                return function (ptype) {
                                    return function (untypedName) {
                                        return function (isLast) {
                                            var convertedName = Doc.lookupName(Data_Ord.ordString)(pname)(propertyNames);
                                            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Control_Applicative.unless(Doc.applicativeDoc)(IRGraph.canBeNull(ptype))(Doc.line("let " + (untypedName + (" = removeNSNull(json[\"" + (stringEscape(pname) + "\"]),"))))))(function () {
                                                return Control_Bind.bind(Doc.bindDoc)(convertAny(ptype)(untypedName))(function (v) {
                                                    return Doc.line("let " + (convertedName + (" = " + (v + (function () {
                                                        if (isLast) {
                                                            return "";
                                                        };
                                                        return ",";
                                                    })()))));
                                                });
                                            });
                                        };
                                    };
                                };
                            }))(function () {
                                return Doc.line("else { return nil }");
                            })))(function () {
                                return Doc.forEachProperty_(properties)(propertyNames)(function (pname) {
                                    return function (v) {
                                        return function (fieldName) {
                                            return function (v1) {
                                                var convertedName = Doc.lookupName(Data_Ord.ordString)(pname)(propertyNames);
                                                return Doc.line("self." + (fieldName + (" = " + convertedName)));
                                            };
                                        };
                                    };
                                });
                            });
                        });
                    });
                }))))(function () {
                    return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("}"))(function () {
                        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.blank)(function () {
                            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("fileprivate var any: Any {"))(function () {
                                return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.indent((function () {
                                    var $102 = Data_Foldable["null"](Data_Map.foldableMap)(properties);
                                    if ($102) {
                                        return Doc.line("return [String: Any]()");
                                    };
                                    return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("return ["))(function () {
                                        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.indent(Doc.forEachProperty_(properties)(propertyNames)(function (pname) {
                                            return function (ptype) {
                                                return function (fieldName) {
                                                    return function (v) {
                                                        return Control_Bind.bind(Doc.bindDoc)(convertToAny(ptype)("self." + fieldName))(function (v1) {
                                                            return Doc.line("\"" + (stringEscape(pname) + ("\": " + (v1 + ","))));
                                                        });
                                                    };
                                                };
                                            };
                                        })))(function () {
                                            return Doc.line("]");
                                        });
                                    });
                                })()))(function () {
                                    return Doc.line("}");
                                });
                            });
                        });
                    });
                });
            })))(function () {
                return Doc.line("}");
            });
        });
    };
};
var renderTopLevelExtensions = function (topLevelName) {
    return function (topLevelType) {
        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.blank)(function () {
            return Control_Bind.bind(Doc.bindDoc)(renderType(topLevelType))(function (v) {
                return Control_Bind.bind(Doc.bindDoc)((function () {
                    if (topLevelType instanceof IRGraph.IRArray) {
                        return Data_Functor.map(Doc.functorDoc)(function (v1) {
                            return "Array where Element == " + v1;
                        })(renderType(topLevelType.value0));
                    };
                    if (topLevelType instanceof IRGraph.IRMap) {
                        return Data_Functor.map(Doc.functorDoc)(function (v1) {
                            return "Dictionary where Key == String, Value == " + v1;
                        })(renderType(topLevelType.value0));
                    };
                    return Control_Applicative.pure(Doc.applicativeDoc)(v);
                })())(function (v1) {
                    return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("extension " + (v1 + " {")))(function () {
                        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.indent(Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("init?(fromString json: String, using encoding: String.Encoding = .utf8) {"))(function () {
                            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.indent(Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("guard let data = json.data(using: encoding) else { return nil }"))(function () {
                                return Doc.line("self.init(fromData: data)");
                            })))(function () {
                                return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("}"))(function () {
                                    return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.blank)(function () {
                                        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("init?(fromData data: Data) {"))(function () {
                                            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.indent(Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("guard let json = try? JSONSerialization.jsonObject(with: data, options: []) else { return nil }"))(function () {
                                                return Doc.line("self.init(fromAny: json)");
                                            })))(function () {
                                                return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("}"))(function () {
                                                    return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)((function () {
                                                        if (topLevelType instanceof IRGraph.IRArray) {
                                                            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.blank)(function () {
                                                                return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("init?(fromAny untyped: Any) {"))(function () {
                                                                    return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.indent(Control_Bind.bind(Doc.bindDoc)(convertAny(topLevelType)("untyped"))(function (v2) {
                                                                        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("guard let elements = " + (v2 + " else { return nil }")))(function () {
                                                                            return Doc.line("self.init(elements)");
                                                                        });
                                                                    })))(function () {
                                                                        return Doc.line("}");
                                                                    });
                                                                });
                                                            });
                                                        };
                                                        if (topLevelType instanceof IRGraph.IRMap) {
                                                            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.blank)(function () {
                                                                return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("init?(fromAny untyped: Any) {"))(function () {
                                                                    return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.indent(Control_Bind.bind(Doc.bindDoc)(convertAny(topLevelType)("untyped"))(function (v2) {
                                                                        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("guard let elements = " + (v2 + " else { return nil }")))(function () {
                                                                            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("self.init()"))(function () {
                                                                                return Doc.line("elements.forEach { self[$0.key] = $0.value }");
                                                                            });
                                                                        });
                                                                    })))(function () {
                                                                        return Doc.line("}");
                                                                    });
                                                                });
                                                            });
                                                        };
                                                        return Control_Applicative.pure(Doc.applicativeDoc)(Data_Unit.unit);
                                                    })())(function () {
                                                        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.blank)(function () {
                                                            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("var jsonData: Data? {"))(function () {
                                                                return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.indent(Control_Bind.bind(Doc.bindDoc)(convertToAny(topLevelType)("self"))(function (v2) {
                                                                    return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("let json = " + v2))(function () {
                                                                        return Doc.line("return try? JSONSerialization.data(withJSONObject: json, options: [])");
                                                                    });
                                                                })))(function () {
                                                                    return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("}"))(function () {
                                                                        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.blank)(function () {
                                                                            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("var jsonString: String? {"))(function () {
                                                                                return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.indent(Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("guard let data = self.jsonData else { return nil }"))(function () {
                                                                                    return Doc.line("return String(data: data, encoding: .utf8)");
                                                                                })))(function () {
                                                                                    return Doc.line("}");
                                                                                });
                                                                            });
                                                                        });
                                                                    });
                                                                });
                                                            });
                                                        });
                                                    });
                                                });
                                            });
                                        });
                                    });
                                });
                            });
                        })))(function () {
                            return Doc.line("}");
                        });
                    });
                });
            });
        });
    };
};
var caseName = function (t) {
    return Data_Functor.map(Doc.functorDoc)(swiftNameStyle(false))(Doc.getTypeNameForUnion(t));
};
var renderUnionDefinition = function (unionName) {
    return function (unionTypes) {
        var v = Utils.removeElement(IRGraph.ordIRType)(function (v1) {
            return Data_Eq.eq(IRGraph.eqIRType)(v1)(IRGraph.IRNull.value);
        })(unionTypes);
        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("enum " + (unionName + " {")))(function () {
            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.indent(Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Data_Foldable.for_(Doc.applicativeDoc)(Data_Set.foldableSet)(v.rest)(function (typ) {
                return Control_Bind.bind(Doc.bindDoc)(caseName(typ))(function (v1) {
                    return Control_Bind.bind(Doc.bindDoc)(renderType(typ))(function (v2) {
                        return Doc.line("case " + (v1 + ("(" + (v2 + ")"))));
                    });
                });
            }))(function () {
                if (v.element instanceof Data_Maybe.Just) {
                    return Control_Bind.bind(Doc.bindDoc)(caseName(v.element.value0))(function (v1) {
                        return Doc.line("case " + v1);
                    });
                };
                if (v.element instanceof Data_Maybe.Nothing) {
                    return Control_Applicative.pure(Doc.applicativeDoc)(Data_Unit.unit);
                };
                throw new Error("Failed pattern match at Language.Swift line 420, column 9 - line 424, column 33: " + [ v.element.constructor.name ]);
            })))(function () {
                return Doc.line("}");
            });
        });
    };
};
var renderUnionExtension = function (unionName) {
    return function (unionTypes) {
        var renderCase = function (t) {
            return Control_Bind.bind(Doc.bindDoc)(convertAny(t)("v"))(function (v) {
                return Control_Bind.bind(Doc.bindDoc)(caseName(t))(function (v1) {
                    return Doc.line("if let x = " + (v + (" { return ." + (v1 + "(x) }"))));
                });
            });
        };
        var v = Utils.removeElement(IRGraph.ordIRType)(function (v1) {
            return Data_Eq.eq(IRGraph.eqIRType)(v1)(IRGraph.IRNull.value);
        })(unionTypes);
        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("extension " + (unionName + " {")))(function () {
            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.indent(Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("fileprivate static func fromJson(_ v: Any) -> " + (unionName + "? {")))(function () {
                return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.indent(Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)((function () {
                    if (v.element instanceof Data_Maybe.Just) {
                        return Control_Bind.bind(Doc.bindDoc)(caseName(v.element.value0))(function (v1) {
                            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("guard let v = removeNSNull(v)"))(function () {
                                return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("else {"))(function () {
                                    return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.indent(Doc.line("return ." + v1)))(function () {
                                        return Doc.line("}");
                                    });
                                });
                            });
                        });
                    };
                    if (v.element instanceof Data_Maybe.Nothing) {
                        return Control_Applicative.pure(Doc.applicativeDoc)(Data_Unit.unit);
                    };
                    throw new Error("Failed pattern match at Language.Swift line 434, column 13 - line 442, column 37: " + [ v.element.constructor.name ]);
                })())(function () {
                    return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Control_Applicative.when(Doc.applicativeDoc)(Data_Set.member(IRGraph.ordIRType)(IRGraph.IRBool.value)(unionTypes))(renderCase(IRGraph.IRBool.value)))(function () {
                        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Control_Applicative.when(Doc.applicativeDoc)(Data_Set.member(IRGraph.ordIRType)(IRGraph.IRInteger.value)(unionTypes))(renderCase(IRGraph.IRInteger.value)))(function () {
                            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Data_Foldable.for_(Doc.applicativeDoc)(Data_Set.foldableSet)(Data_Set.difference(IRGraph.ordIRType)(v.rest)(Data_Set.fromFoldable(Data_Foldable.foldableArray)(IRGraph.ordIRType)([ IRGraph.IRBool.value, IRGraph.IRInteger.value ])))(function (typ) {
                                return renderCase(typ);
                            }))(function () {
                                return Doc.line("return nil");
                            });
                        });
                    });
                })))(function () {
                    return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("}"))(function () {
                        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.blank)(function () {
                            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("fileprivate var any: Any {"))(function () {
                                return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.indent(Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("switch self {"))(function () {
                                    return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Data_Foldable.for_(Doc.applicativeDoc)(Data_Set.foldableSet)(unionTypes)(function (typ) {
                                        return Control_Bind.bind(Doc.bindDoc)(caseName(typ))(function (v1) {
                                            var letString = (function () {
                                                var $130 = Data_Eq.eq(IRGraph.eqIRType)(typ)(IRGraph.IRNull.value);
                                                if ($130) {
                                                    return "";
                                                };
                                                return "(let x)";
                                            })();
                                            return Control_Bind.bind(Doc.bindDoc)(convertToAny(typ)("x"))(function (v2) {
                                                return Doc.line("case ." + (v1 + (letString + (": return " + v2))));
                                            });
                                        });
                                    }))(function () {
                                        return Doc.line("}");
                                    });
                                })))(function () {
                                    return Doc.line("}");
                                });
                            });
                        });
                    });
                });
            })))(function () {
                return Doc.line("}");
            });
        });
    };
};
var swiftDoc = Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("// To parse the JSON, add this file to your project and do:"))(function () {
    return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("//"))(function () {
        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.forEachTopLevel_(function (topLevelName) {
            return function (topLevelType) {
                return Control_Bind.bind(Doc.bindDoc)(renderType(topLevelType))(function (v) {
                    return Doc.line("//   let " + (Data_String_Util.decapitalize(topLevelName) + (" = " + (topLevelName + "(fromString: jsonString)!"))));
                });
            };
        }))(function () {
            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.blank)(function () {
                return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("import Foundation"))(function () {
                    return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.blank)(function () {
                        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.renderRenderItems(Doc.blank)(new Data_Maybe.Just(renderTopLevelAlias))(renderClassDefinition)(new Data_Maybe.Just(renderUnionDefinition)))(function () {
                            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.blank)(function () {
                                return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.line("// Serialization extensions"))(function () {
                                    return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.forEachTopLevel_(renderTopLevelExtensions))(function () {
                                        return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.forEachClass_(function (className) {
                                            return function (properties) {
                                                return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.blank)(function () {
                                                    return renderClassExtension(className)(properties);
                                                });
                                            };
                                        }))(function () {
                                            return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.forEachUnion_(function (unionName) {
                                                return function (unionTypes) {
                                                    return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.blank)(function () {
                                                        return renderUnionExtension(unionName)(unionTypes);
                                                    });
                                                };
                                            }))(function () {
                                                return Control_Bind.discard(Control_Bind.discardUnit)(Doc.bindDoc)(Doc.blank)(function () {
                                                    return supportFunctions;
                                                });
                                            });
                                        });
                                    });
                                });
                            });
                        });
                    });
                });
            });
        });
    });
});
var renderer = {
    name: "Swift", 
    aceMode: "swift", 
    extension: "swift", 
    doc: swiftDoc, 
    transforms: {
        nameForClass: Doc.simpleNamer(IRGraph.ordIRClassData)(nameForClass), 
        nextName: function (s) {
            return "Other" + s;
        }, 
        forbiddenNames: keywords, 
        topLevelName: Doc.forbidNamer(Data_Ord.ordString)(swiftNameStyle(true))(function (n) {
            return [ swiftNameStyle(true)(n) ];
        }), 
        unions: new Data_Maybe.Just({
            predicate: Doc.unionIsNotSimpleNullable, 
            properName: Doc.simpleNamer(IRGraph.ordNamed(Data_Set.ordSet(Data_Ord.ordString)))(function ($136) {
                return swiftNameStyle(true)(Doc.combineNames($136));
            }), 
            nameFromTypes: Doc.simpleNamer(Data_Ord.ordArray(Data_Ord.ordString))(Doc.unionNameIntercalated(swiftNameStyle(true))("Or"))
        })
    }
};
module.exports = {
    renderer: renderer
};
//# sourceMappingURL=index.js.map
